﻿using System;
using System.Collections.Generic;
using System.Text;
using Foss.FossDoc.ObjectModel.DataRepresentation.View.DocumentCard;
using Foss.FossDoc.ObjectModel.Data;
using Converters = Foss.FossDoc.ApplicationServer.Converters;
using Foss.FossDoc.ApplicationServer;

// Заменить уникальное имя типа документа (new_library.новый_тип.x20102850)
// на уникальноеимя своего типа документа
namespace Foss.FossDoc.Plugins.DocumentLibrary.new_library.новый_тип.x20102850
{
	public class Form : Foss.FossDoc.ObjectModel.DataRepresentation.View.DocumentCard.DocumentCardInplaceForm
	{
		Foss.FUIS.Action _ActionChangeRights;
		
		public override void Activate()
		{
			base.Activate();

			_GenerateDisplayNameAndDisableField();
		}


		private void _GenerateDisplayNameAndDisableField()
		{
			IDocumentCardField documentCardField = Fields[Foss.FossDoc.ApplicationServer.ObjectDataManagment.Schema.PropertyTags.DisplayName];
			if (documentCardField == null)
				return;

			documentCardField.ReadOnly = true;

			if (IsNew)
			{
				documentCardField.Value = _GenerateDisplayName();
			}
		}

		private string _GenerateDisplayName()
		{
			string employeeName;
			using (IObjectHolder employee = ObjectHolder.Session.OpenObject(ObjectHolder.Session.ActAsUserOID))
			{
				employeeName = employee.DisplayName;
			}

			return string.Format(
					"{0} ({1}) {2}",
					ObjectHolder.Category.DisplayName,
					employeeName,
					ObjectHolder.Session.UTCTime.ToLocalTime());
		}

		protected override void SaveRoutine()
		{
			base.SaveRoutine();
		}
	}
}
